import { Resource } from 'cdktf';
import { Construct } from 'constructs';
/**
 * @stability stable
 */
export interface AddSecurityHubMemberAccountOptions {
    /**
     * @stability stable
     */
    readonly accountId: string;
    /**
     * @stability stable
     */
    readonly email: string;
}
/**
 * @stability stable
 */
export declare class EnableSecurityHub extends Resource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, name: string);
    /**
     * Add Config Rule for Security Hub enabled.
     *
     * @param tags Config Rule tags.
     * @stability stable
     */
    addConfigRule(tags?: any): void;
    /**
     * Add Member Account of Security Hub.
     *
     * @param id Security Hub member id.
     * @param options Security Hub options.
     * @stability stable
     */
    addSecurityHubMemberAccount(id: string, options: AddSecurityHubMemberAccountOptions): void;
}
